#include "common.h"

list_file* get_list_file(char *dirname, int *max_count) {
	msg("get_list_file()\n");
	DIR *dir_ptr; /* the directory */
	struct dirent *direntp; /* each entry */
	//printf("dirpath %s\n",dirname);
	//strncpy(pub_present_path,dirname,strlen(dirname));
	list_file *p=NULL;
	list_file *head=NULL;

	//printf("start get_list_file()3\n");
	//printf("before head %p\n",head);
	head=(list_file*)malloc(sizeof(list_file));
	//printf("after head %p\n",head);
	//printf("::: Malloc :::\n");
	//printf("start get_list_file()4\n");
	pub_head=NULL;
	pub_head = head;
	head->Next=NULL;
	//printf("list_file() check\n");

	if ( (dir_ptr = opendir(dirname) ) == NULL) {
		fprintf(stderr,"ls1: cannot open %s\n", dirname);
	} else {
		//printf("else\n");
		while ( (direntp = readdir(dir_ptr) ) != NULL) {
			//printf("dostat\n");
			dostat(dirname, direntp->d_name, head);

		}
	}
	p=head;
	int i=0;
	//printf("list_file() while before\n");
	while (p=p->Next) {
		p->data.count=++i;
		//printf(" ====%d\n",p->data.count);
		//printf("list.c %d %s\r\t\t\t\t\t\t\t %6.1f %s  %s\n",p->data.isdir,p->data.initial,p->data.size,p->data.unit,p->data.date);
		//printf("   %s\n",p->data.date);
	}

	//printf("after while\n");
	*max_count=i;
	closedir(dir_ptr);
	return head;
}

void dostat(char *dirname, char *filename, list_file *head) {
	//msg("start dostat()\n");

	struct stat info;

	//	list_file *node=(list_file *)malloc(sizeof(list_file));
	char path[strlen(dirname)+strlen(filename)+2];
	memset(path, 0x0, sizeof(path));
	snprintf(path, (strlen(dirname)+strlen(filename))+2, "%s/%s", dirname,
			filename);

	if (pub_mode==1) {
		/*
		// ϶   .
		//printf("\n");
		if (stat(path, &info) == -1) {
			perror(filename);
		} else {
			if (strcmp(filename, ".")==0 || strcmp(filename, "..")==0
					||strncmp(filename, ".", 1)==0) {
				;
			} else {

				show_file_info(path, &info, head, filename);
			}

		}
		*/
		if (stat(path, &info) == -1) {
			perror(filename); /* say why */
		} else {
			if (strcmp(filename, ".")==0 || strcmp(filename, "..")==0) {
				;
			} else {

				show_file_info(path, &info, head, filename);
			}

		}

	} else {
		if (stat(path, &info) == -1) {
			perror(filename); /* say why */
		} else {
			if (strcmp(filename, ".")==0 || strcmp(filename, "..")==0) {
				;
			} else {

				show_file_info(path, &info, head, filename);
			}

		}

	}
	//msg("end start dostat()\n");

}
void show_file_info(char *path, struct stat *info_p, list_file *head,
		char *filename) {
	//msg("show_file_info()\n");
	//printf("Start show_file_info()\n");
	struct tm *tm_ptr;
	char buffer[9];
	int i,index=0;
	list_file *t;
	tm_ptr=localtime(&info_p->st_ctime);

	strftime(buffer, 9, "%y/%m/%d", tm_ptr);
	list_file* node=(list_file*)malloc(sizeof(list_file));
	//printf("::: Malloc() ::: %d\n",sizeof(list_file));

	node->Next=NULL;
	node->data.ori_date=info_p->st_ctime;
	node->data.ori_size = 0;
	if ( S_ISDIR(info_p->st_mode))
		node->data.isdir=1;
	else
		node->data.isdir=0;
	memset(node->data.filename, 0x0, 256);
	strncpy(node->data.filename, filename, strlen(filename));
	//printf(" %s ,f %d,p %d\n",node->data.filename,strlen(filename),strlen(node->data.filename));
	memset(node->data.date, 0x0, 9);
	strncpy(node->data.date, buffer, 9);
	node->data.date[strlen(node->data.date)] = '\0';
	strncpy(node->data.initial, filename, 50-3);

	//printf("%d , %d , %d\n",node->data.initial[3],node->data.initial[4],node->data.initial[5]);



	for( i=0; i < 42 ;i++ ) {
		if(( node->data.initial[i]) <0) {
			index++;
		}
	}
	if((index % 2)==0) {
		node->data.initial[40]='.';
		node->data.initial[41]='.';
		node->data.initial[42]='\0';

	}
	else {
		node->data.initial[41]='.';
		node->data.initial[42]='\0';
	}




	if (S_ISDIR(info_p->st_mode)) {
		node->data.size=0;
		strncpy(node->data.unit, "  ", 2);

	} else {
		if (((long)info_p->st_size) > 1000000) {
			strncpy(node->data.unit, "MB", 2);
			node->data.size=(float)((long)info_p->st_size) / 1000000;
			node->data.unit[2]='\0';
			node->data.ori_size = (long)info_p->st_size;

		} else {
			node->data.size=(float)((long)info_p->st_size) / 1000;
			strncpy(node->data.unit, "KB", 2);
			node->data.unit[2]='\0';
			node->data.ori_size = (long)info_p->st_size;

		}
	}
	//printf("%s\n",node->data.date);

	list_file *p;
	p=head;

	if (p==NULL) {
		head->Next=node;
	} else {
		while (p->Next!=NULL) {

			t=p->Next;

			if (t->data.ori_date < node->data.ori_date) {

				t=p->Next;
				p->Next=node;
				node->Next=t;
				break;
			}
			p=p->Next;

		}
		p->Next=node;
	}
	//msg("end show_file_info()\n");

}
void delete_all(list_file *head, int max_count) {
	//msg("delete_all()\n");
	list_file *p=NULL;
	list_file *t=NULL;

	p=head;
	//msg("delete_all(1)\n");
	/*
	while (p=p->Next) {

		//printf("list check\n");
	}
	*/
	if(head == NULL) {
		return;
	}
	p=head;
	p=p->Next;
	//msg("delete_all(2)\n");
	while ((p)!=NULL && max_count!=0) {
		//printf("p = %p\n",p);
		t=p->Next;
		free(p);

		p=t;
		//printf("::: free()\n");
	}
	//msg("delete_all(3)\n");
	//
	//printf("head free()\n");
	//head->Next=NULL;
	t=p=NULL;
	free(head);
	/*

	 p=head;

	 while((p->Next)!=NULL && max_count !=0) {
	 t=p->Next;

	 free(p);
	 p=t;
	 printf("free()\n");

	 }

	 printf("head free()\n");
	 t=p=NULL;
	 free(head);
	 */

}
